[<RequireQualifiedAccess>]
module Download

open FSharp.Data

open Deedle

/// Downloads data from EOD Historical Data for one stock.
let downloadFromEOD (storageDataPath: string) (symbol: string) : unit =
    
    // Token for the EOD Historical Data service
    let apiToken = "99999999999999" // insert your EOD token here

    let endStr = "?api_token=" + apiToken + "&period=d&order=d"

    printfn "Downloading symbol %s" symbol 

    let url = @"http://eodhistoricaldata.com/api/eod/" + symbol + endStr

    let df =
        Http.RequestString(url)
        |> DeedleFuncs.Frame.stringToTSDF
    
    let path = storageDataPath + symbol + ".csv"
    
    FrameExtensions.SaveCsv(df, path, includeRowKeys=true, keyNames=["Date"])
