open Deedle

[<EntryPoint>]
let main argv =

    let dropboxRoot = "C:\\" // or whenever your Dropbox folder is

    // File with list of tickers of stocks to be downloaded
    let eODAssetsPath = dropboxRoot + @"\Dropbox\Excel\Data\Fractal\EOD.csv"

    // Data stored in this folder
    let storageDataPath  = dropboxRoot + @"\Dropbox\Excel\Data\Fractal\Data\"

    // Tickers to be downloaded from EOD Historical Data
    // The CSV file in eODAssetsPath contains a column labeled Ticker with
    // the tickers of the stocks to be downloaded from EOD Historical Data
    let eODTickers : string seq =
        Frame.ReadCsv(eODAssetsPath, hasHeaders=true, inferTypes=false)
        |> Frame.getCol "Ticker"
        |> Series.dropMissing
        |> Series.filterValues (fun x -> x <> "")
        |> Series.values

    Seq.iter (Download.downloadFromEOD storageDataPath) eODTickers

    printfn "%A" argv
    0 // return an integer exit code
